###################################################
### chunk number 1: 
###################################################
#line 119 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
options(scipen=3, digits=4)
### for sampling
set.seed(1234)


###################################################
### chunk number 2: 
###################################################
#line 929 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
library("seriation")

data("iris")
x <- as.matrix(iris[-5])
x <- x[sample(seq_len(nrow(x))),]
d <- dist(x)


###################################################
### chunk number 3: 
###################################################
#line 941 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
o <- seriate(d)
o


###################################################
### chunk number 4: 
###################################################
#line 954 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
head(get_order(o), 15)


###################################################
### chunk number 5: pimage1
###################################################
#line 963 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
pimage(d, main = "Random")


###################################################
### chunk number 6: pimage1-2
###################################################
#line 966 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
pimage(d, o, main = "Reordered")


###################################################
### chunk number 7: 
###################################################
#line 980 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
cbind(random = criterion(d), reordered = criterion(d, o))


###################################################
### chunk number 8: pimage2
###################################################
#line 1002 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
pimage(x, main = "Random")


###################################################
### chunk number 9: pimage2-2
###################################################
#line 1006 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
o_2mode <- c(o, ser_permutation(seq_len(ncol(x))))
#o_2mode
pimage(x, o_2mode, main = "Reordered")


###################################################
### chunk number 10: 
###################################################
#line 1027 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
methods <- c("TSP","Chen", "ARSA", "HC", "GW", "OLO")
o <- sapply(methods, FUN = function(m) seriate(d, m), simplify = FALSE)


###################################################
### chunk number 11: 
###################################################
#line 1032 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
timing <- sapply(methods, FUN = function(m) system.time(seriate(d, m)), 
    simplify = FALSE)


###################################################
### chunk number 12: pimage3-pre eval=FALSE
###################################################
## #line 1072 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
## tmp <- lapply(o, FUN = function(x) pimage(d, x, main = get_method(x[[1]])))


###################################################
### chunk number 13: pimage3
###################################################
#line 1075 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
for(i in 1:length(o)) {
    pdf(file=paste("seriation-pimage_comp_", i , ".pdf", sep=""))
    pimage(d, o[[i]], main = get_method(o[[i]][[1]]))
    dev.off()
}



###################################################
### chunk number 14: pimage3_dend eval=FALSE
###################################################
## #line 1124 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
## plot(o[["HC"]][[1]], labels = FALSE, main = "Dendrogram HC")
## plot(o[["GW"]][[1]], labels = FALSE, main = "Dendrogram GW")


###################################################
### chunk number 15: 
###################################################
#line 1128 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
def.par <- par(no.readonly = TRUE)
pdf(file="seriation-pimage3_dendrogram.pdf", width=9, height=4) 
layout(t(1:2))
plot(o[["HC"]][[1]], labels = FALSE, main = "Dendrogram HC")
symbols(74.7,.5, rect = matrix(c(4, 3), ncol=2), add= TRUE, 
    inches = FALSE, lwd =2)

plot(o[["GW"]][[1]], labels = FALSE, main = "Dendrogram GW")
symbols(98.7,.5, rect = matrix(c(4, 3), ncol=2), add= TRUE, 
    inches = FALSE, lwd =2)
par(def.par)
tmp <- dev.off()


###################################################
### chunk number 16: 
###################################################
#line 1158 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
crit <- sapply(o, FUN = function(x) criterion(d, x))
t(crit)


###################################################
### chunk number 17: crit1
###################################################
#line 1163 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
def.par <- par(no.readonly = TRUE)
m <- c("Path_length", "AR_events", "Moore_stress")
layout(matrix(seq_along(m), ncol=1))
#tmp <- apply(crit[m,], 1, dotchart, sub = m)
tmp <- lapply(m, FUN = function(i) dotchart(crit[i,], sub = i))
par(def.par)


###################################################
### chunk number 18: 
###################################################
#line 1202 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
show_seriation_methods("dist")
show_seriation_methods("matrix")


###################################################
### chunk number 19: 
###################################################
#line 1211 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
list_seriation_methods("matrix")


###################################################
### chunk number 20: 
###################################################
#line 1228 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
seriation_method_identity <- function(x, control) {
           lapply(dim(x), seq)
}


###################################################
### chunk number 21: 
###################################################
#line 1239 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
set_seriation_method("matrix", "identity", seriation_method_identity,
    "Identity order")

set_seriation_method("array", "identity", seriation_method_identity,
    "Identity order")


###################################################
### chunk number 22: 
###################################################
#line 1249 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
show_seriation_methods("matrix")

o <- seriate(matrix(1, ncol=3, nrow=4), "identity")
o

get_order(o, 1)
get_order(o, 2)


###################################################
### chunk number 23: 
###################################################
#line 1290 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
x <- scale(x, center = FALSE)


###################################################
### chunk number 24:  eval=FALSE
###################################################
## #line 1297 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
## hmap(x)


###################################################
### chunk number 25:  eval=FALSE
###################################################
## #line 1308 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
## hmap(x, hclustfun = NULL)


###################################################
### chunk number 26: 
###################################################
#line 1319 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
bitmap(file = "seriation-heatmap1.png", type = "pnggray", 
    height = 6, width = 6, res = 300, pointsize=14)
hmap(x, cexCol=1, labRow = "", margin =c(7,7))
tmp <- dev.off()


###################################################
### chunk number 27: 
###################################################
#line 1325 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
pdf(file = "seriation-heatmap2.pdf")
hmap(x, hclustfun = NULL)
tmp <- dev.off()


###################################################
### chunk number 28: 
###################################################
#line 1394 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
data("Irish")
orig_matrix <- apply(Irish[,-6], 2, rank)


###################################################
### chunk number 29: 
###################################################
#line 1406 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
o <- c(
    seriate(dist(orig_matrix, "minkowski", p = 1), method ="TSP"),
    seriate(dist(t(orig_matrix), "minkowski", p = 1), method = "TSP")
)
o


###################################################
### chunk number 30:  eval=FALSE
###################################################
## #line 1416 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
## bertinplot(orig_matrix)
## bertinplot(orig_matrix, o)


###################################################
### chunk number 31: bertin1
###################################################
#line 1420 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
bertinplot(orig_matrix)


###################################################
### chunk number 32: bertin2
###################################################
#line 1423 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
bertinplot(orig_matrix, o)


###################################################
### chunk number 33: binary1
###################################################
#line 1484 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
data("Townships")

bertinplot(Townships, options = list(panel=panel.squares, spacing = 0, 
    frame = TRUE))


###################################################
### chunk number 34: 
###################################################
#line 1496 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
## to get consistent results
set.seed(5)


###################################################
### chunk number 35: binary2
###################################################
#line 1501 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
o <- seriate(Townships, method = "BEA", control = list(rep = 10))
bertinplot(Townships, o, options = list(panel=panel.squares, spacing = 0,
    frame = TRUE))


###################################################
### chunk number 36: 
###################################################
#line 1538 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
rbind(original = criterion(Townships), reordered = criterion(Townships, o))


###################################################
### chunk number 37: 
###################################################
#line 1606 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
data("iris")
iris <- iris[sample(seq_len(nrow(iris))),]
d <- dist(as.matrix(iris[-5]), method = "euclidean")


###################################################
### chunk number 38: dissplot1 eval=FALSE
###################################################
## #line 1621 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
## ## plot original matrix
## dissplot(d, method = NA)


###################################################
### chunk number 39: dissplot2 eval=FALSE
###################################################
## #line 1626 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
## ## plot reordered matrix
## dissplot(d, options = list(main = "Dissimilarity plot with seriation"))


###################################################
### chunk number 40: 
###################################################
#line 1631 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
pdf(file = "seriation-dissplot1.png")
#line 1621 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw#from line#1632#"
## plot original matrix
dissplot(d, method = NA)
#line 1633 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
tmp <- dev.off()
pdf(file = "seriation-dissplot2.png")
#line 1626 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw#from line#1635#"
## plot reordered matrix
dissplot(d, options = list(main = "Dissimilarity plot with seriation"))
#line 1636 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
tmp <- dev.off()


###################################################
### chunk number 41: 
###################################################
#line 1664 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
set.seed(1234)


###################################################
### chunk number 42: 
###################################################
#line 1667 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
l <- kmeans(d, 10)$cluster
#$


###################################################
### chunk number 43: dissplot3 eval=FALSE
###################################################
## #line 1678 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
## res <- dissplot(d, labels = l,
##     options = list(main = "Dissimilarity plot - standard"))


###################################################
### chunk number 44: 
###################################################
#line 1682 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
pdf(file = "seriation-dissplot3.pdf")

## visualize the clustering
#line 1678 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw#from line#1685#"
res <- dissplot(d, labels = l,
    options = list(main = "Dissimilarity plot - standard"))
#line 1686 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
tmp <- dev.off()


pdf(file = "seriation-dissplot4.png")
## threshold
plot(res, options = list(main = "Dissimilarity plot - threshold", 
    threshold = 1.5))

tmp <- dev.off()


###################################################
### chunk number 45: 
###################################################
#line 1710 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
res


###################################################
### chunk number 46:  eval=FALSE
###################################################
## #line 1730 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
## plot(res, options = list(main = "Seriation - threshold",
##     threshold = 1.5))


###################################################
### chunk number 47: 
###################################################
#line 1746 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
#names(res)
table(iris[res$order, 5], res$label)[,res$cluster_order]
#$


###################################################
### chunk number 48: ruspini
###################################################
#line 1765 "d:/Rcompile/CRANpkg/local/2.12/seriation/inst/doc/seriation.Rnw"
data("ruspini")
d <- dist(ruspini)
l <- kmeans(d, 3)$cluster
dissplot(d, labels = l)


